/****************************************************************************************** 
 *	Chili DirectX Framework Version 12.04.24											  *	
 *	D3DGraphics.h																		  *
 *	Copyright 2012 PlanetChili <http://www.planetchili.net>								  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#pragma once

#include <d3d9.h>
#define SCREENWIDTH 800
#define SCREENHEIGHT 600

class D3DGraphics
{

public:
	D3DGraphics( HWND hWnd );
	~D3DGraphics();
	void PutPixel( int x,int y,int r,int g,int b );
	void PutPixelClipped( int x,int y,int r,int g,int b );
	void DrawLine( int x1,int y1,int x2,int y2,int r,int g,int b );
	void DrawLineClipped(int x1, int y1, int x2, int y2, int r, int g, int b);
	void DrawCircle( int cx,int cy,int radius,int r,int g,int b );
	void DrawDisc( int cx,int cy,int r,int rd,int g,int b );
	void DrawBoxClipped(int x, int y, int x2, int y2, int r, int g, int b);
	void DrawBoxUnclipped(int x, int y, int x2, int y2, int r, int g, int b);
	void DrawSpike(int x, int y,  int r, int g, int b);
	void DrawDoorClipped(int x1, int y1);
	void DrawPlayer(int x, int y);
	void DrawGun(int x, int y);
	void DrawParticleClipped(int x, int y, int r, int g, int b);
	void DrawEnemy(int x, int y);
	void DrawBullet(int x, int y);
	void DrawMiniGame(int x, int y, int x1, int y1, int x2, int y2);
	void DrawGameOver(int x, int y);
	void BeginFrame();
	void EndFrame();
private:
	IDirect3D9*			pDirect3D;
	IDirect3DDevice9*	pDevice;
	IDirect3DSurface9*	pBackBuffer;
	D3DLOCKED_RECT		backRect;
};